﻿;======================================================================
; Module/File:     LIG_CellSelect&Edit #2.pb - Linux
; Function:        LIG: Zellen per Doppelklick editieren, half nativ - Linux
; Author:          Oma (Charly Bauer)
; Date:            Juli 07, 2014
; Version:         0.1
; Target Compiler: PureBasic 5.22 LTS - Linux x86
; Target OS:       Linux - Xubuntu
; License:         Free, unrestricted, no warranty
;======================================================================
;
;todo / Problem
; Editfeld läßt sich nicht als Child des LIG definieren (Fehlermeldung bei gtk_widget_set_parent ())
; Scrollen des LIG noch möglich, Editfeld bleibt jedoch auf abs. Position, s.o.
; Sperren des Scrollens noch nicht gefunden
; Funktionen sollten noch in eine Hauptproutine - keine mehrfache Abfragen in Event-Schleife - keine Globalen Variablen mehr nötig
; LIG_Edit_Close(Window, Gadget, Edit, Type) - Case: Events noch ausmisten
;


EnableExplicit

ImportC ""
	;gtk_tree_view_convert_tree_to_widget_coords(*tree_view.GtkTreeView, bx.I, by.I, *wx, *wy)
	;gtk_tree_view_convert_tree_to_bin_window_coords(*tree_view.GtkTreeView, bx.I, by.I, *wx, *wy)
	;gtk_tree_view_convert_widget_to_bin_window_coords(*tree_view.GtkTreeView, bx.I, by.I, *wx, *wy)
	;gtk_tree_view_convert_bin_window_to_tree_coords(*tree_view.GtkTreeView, bx.I, by.I, *wx, *wy)
	gtk_tree_view_convert_bin_window_to_widget_coords(*tree_view.GtkTreeView, bx.I, by.I, *wx, *wy)
EndImport

Structure TREE_FOREACH_DATA
	TreePath.l
	ItemIndex.l
EndStructure

Structure LIGCELLDATA
	Path.l;    Zeile
	Column.l;  Spalte
	xFrame.l;  Header-X-Offset
	yFrame.l;  Header-Y-Offset (Höhe)
EndStructure
Global LigCellData.LIGCELLDATA


#Win  = 0
#List = 0
#Text = 1
#Edit = 2

Global.l gEvent, gGadget, gEventType, gMenu;, gItemIndex, gColumnIndex
Global.i I, J
Global.s gText


;- Functions ...
ProcedureC tree_foreach(*Model, *Path, *Iter, *user_data.TREE_FOREACH_DATA)
	If gtk_tree_path_compare_(*Path, *user_data\TreePath) = 0
		ProcedureReturn #True
	Else
		*user_data\ItemIndex + 1
		ProcedureReturn #False   
	EndIf
EndProcedure

Procedure LIG_Edit_Start(Window, Gadget, Edit, Text.s, x, y, w, h);   Koordinaten nach als GdkRectangle übergeben
	UseGadgetList(Window)
	AddKeyboardShortcut(Window, #PB_Shortcut_Return, #PB_Key_Return)
	AddKeyboardShortcut(Window, #PB_Shortcut_Escape, #PB_Key_Escape)
	AddKeyboardShortcut(Window, #PB_Shortcut_Up, #PB_Key_Up)
	AddKeyboardShortcut(Window, #PB_Shortcut_Down, #PB_Key_Down)
	AddKeyboardShortcut(Window, #PB_Shortcut_F2, #PB_Key_F2)
	StringGadget(Edit, x, y, w, h, "")
	SetGadgetText(Edit, Text)
	SetActiveGadget(Edit)
EndProcedure

Procedure.b LIG_Edit_Close(Window, Gadget, Edit, Type)
	Protected.b Close= #False, Valid= #True, NextRow= -1
	Debug "Type  : " + Str(Type)
	Select Type
		Case #PB_EventType_LostFocus
			Close= #True
		Case #PB_EventType_LeftClick; clicked
			Close= #True
		Case #PB_Key_Escape, #PB_Shortcut_Escape
			Close= #True
			Valid= #False
		Case #PB_Key_Return, #PB_EventType_ReturnKey
			Close= #True
		Case #PB_Key_Scroll, #PB_EventType_KeyUp, #PB_EventType_KeyDown, #PB_EventType_Up, #PB_EventType_Down, #PB_Key_Up, #PB_Key_Down
			Close= #True
		Case #PB_Shortcut_Return, #PB_Shortcut_Up, #PB_Shortcut_Down
			Close= #True
	EndSelect
	If Close
		If IsGadget(Edit)
			RemoveKeyboardShortcut(Window, #PB_Shortcut_Return)
			RemoveKeyboardShortcut(Window, #PB_Shortcut_Escape)
			RemoveKeyboardShortcut(Window, #PB_Shortcut_Up)
			RemoveKeyboardShortcut(Window, #PB_Shortcut_Down)
			If Valid
				SetGadgetItemText(gadget, LigCellData\Path, GetGadgetText(#edit), LigCellData\Column)
			EndIf
			FreeGadget(Edit)
		EndIf
		If Type= #PB_Shortcut_Down Or Type= #PB_Key_Down
			If LigCellData\Path< CountGadgetItems(Gadget)
				SetGadgetState(Gadget, LigCellData\Path+ 1)
			EndIf
		EndIf
	EndIf
EndProcedure

Procedure LIG_CellEdit(Window, Gadget, Edit)
	Protected.l mX, mY, xOffs, yOffs
	Static *TreePath, *TreeColumn
	Protected *ColumnList.GList
	Protected foreach_data.TREE_FOREACH_DATA
	Protected ItemIndex= -1, ColumnIndex= -1, Rect.GdkRectangle
	
	;kann durch gtk_tree_view_get_cursor_(GadgetID(#LIG), @*gTPath, @*gTColumn) ersetzt werden
	
	gdk_window_get_pointer_(gtk_tree_view_get_bin_window_(GadgetID(Gadget)), @mX, @mY, 0);    Fensterrelative Mauskoordinate

	If gtk_tree_view_get_path_at_pos_(GadgetID(Gadget), mX, mY, @*TreePath, @*TreeColumn, #Null, #Null)
		If GadgetType(Gadget) = #PB_GadgetType_Tree
			foreach_data\TreePath = *TreePath
			gtk_tree_model_foreach_(gtk_tree_view_get_model_(GadgetID(Gadget)), @tree_foreach(), @foreach_data)
			ItemIndex = foreach_data\ItemIndex
		Else
			ItemIndex = PeekL(gtk_tree_path_get_indices_(*TreePath))
		EndIf
		
		*ColumnList = gtk_tree_view_get_columns_(GadgetID(Gadget))
		ColumnIndex = g_list_index_(*ColumnList, *TreeColumn)
		Debug "Spalten: " + Str(g_list_length_(*ColumnList))
		
		If ItemIndex> -1 And ColumnIndex> -1;                        rel. Cellposition
			gtk_tree_view_get_cell_area_ (GadgetID(Gadget), *TreePath, *TreeColumn, @Rect);             Relativ zu Zellbereich
			Debug "Position: x:"+Str(Rect\x) + "  y:"+Str(Rect\y) + "  w:"+Str(Rect\width) + "  h:"+Str(Rect\height)
			Debug "path: " + ItemIndex + ", column: " + ColumnIndex;                                    Zeile und Spalte
			
			gtk_tree_view_convert_bin_window_to_widget_coords(GadgetID(Gadget), 0, 0, @xOffs, @yOffs);  Der Versatz zum Gadget-Nullpunkt (mit Header)
			Debug "Abstand zu Gadget: x:" + Str(xOffs) + ", y:" + Str(yOffs)
			
			LIG_Edit_Start(Window, Gadget, Edit, GetGadgetItemText(Gadget, ItemIndex, ColumnIndex), Rect\x + xOffs + GadgetX(Gadget), Rect\y + yOffs + GadgetY(Gadget), Rect\width, Rect\height)
			
			With LigCellData
				\Path  = ItemIndex
				\Column= ColumnIndex
				\xFrame= xOffs
				\yFrame= yOffs
			EndWith
			
			gtk_tree_path_free_(*TreePath)
			g_list_free_(*ColumnList)
		EndIf
	EndIf
EndProcedure


; ============================================================
;- Example
; ============================================================

If OpenWindow(#Win, 0, 0, 400, 300, "Cell Select & Edit", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
	TextGadget(#Text, 10, 260, 280, 30, "", #PB_Text_Border)
	ListIconGadget(#List, 10, 10, 380, 240, "Col 0", 60)
	For I = 1 To 6
		AddGadgetColumn(#List, i, "Col " + Str(i), 60)
	Next i
	
	For I = 0 To 25
		gText = ""
		For J = 0 To 6
			gText + Str(I) + "x" + Str(J) + Chr(10)
		Next J
		AddGadgetItem(#List, -1, gText)
	Next I
	
	Repeat
		gEvent = WaitWindowEvent()
		
		If EventWindow()= #Win
			If gEvent= #PB_Event_Gadget
				gGadget= EventGadget()
				If gGadget= #List
					gEventType= EventType()
					Select gEventType
						Case #PB_EventType_LeftDoubleClick
							LIG_CellEdit(#Win, #List, #Edit)
; 						Case #PB_EventType_LeftClick;, #PB_EventType_KeyUp, #PB_EventType_KeyDown, #PB_EventType_Up, #PB_EventType_Down;
; 							LIG_Edit_Close(#Win, #List, #Edit, 0, gEventType)
					EndSelect
				EndIf
				If gGadget= #Edit
					gEventType= EventType()
					Select gEventType
						Case #PB_EventType_LostFocus
							LIG_Edit_Close(#Win, #List, #Edit, gEventType)
					EndSelect
				EndIf
			EndIf
			If gEvent= #PB_Event_Menu
				gMenu= EventMenu()
				Select gMenu
						Case #PB_Key_Return, #PB_Key_Escape, #PB_Key_Up, #PB_Key_Down
							LIG_Edit_Close(#Win, #List, #Edit, gMenu)
; 						Case #PB_Key_F2
; 							LIG_CellEdit(#Win, #List, #Edit)
				EndSelect
			EndIf
		EndIf
		
	Until gEvent= #PB_Event_CloseWindow
EndIf
; IDE Options = PureBasic 5.30 (Linux - x86)
; CursorPosition = 163
; FirstLine = 138
; Folding = -
; EnableXP
; DisableDebugger
; CurrentDirectory = /home/charly-xubuntu/Programming/PureBasic/purebasic/