﻿;======================================================================
; Module/File:     LIG_ColumnAlignmentSet.pb - Linux
; Function:        LIG: Ausrichtung des Spalteninhaltes - Linux
; Author:          Oma (Charly Bauer) + freak-example
; Date:            Juli 27, 2014
; Version:         0.2
; Target Compiler: PureBasic 5.22 LTS - Linux x86
; Target OS:       Linux - Xubuntu
; License:         Free, unrestricted, no warranty
;======================================================================

ImportC ""
	g_object_set_double(*Object, Property.P-ASCII, Value.D, Null) As "g_object_set"
	gtk_tree_view_column_set_alignment(*tree_column, xalign.f);             replaced PureBasic's V5.22 buggy: gtk_tree_view_column_set_alignment_(*Column, Alignment)
EndImport

;Alignment:
; 0.0 = Left
; 0.5 = Center
; 1.0 = Right

; Object constants
#MainWin= 0
#LIG    = 0

#WinX= 300
#WinY= 200
#WinW= 500
#WinH= 400

Global.l gEvent, gQuit

Procedure SetListIconColumnFormat(Gadget, Colmn, Alignment.d)
	Protected *Column, *CellRenderers
	Protected.l Count, Index
 
  *Column = gtk_tree_view_get_column_(GadgetID(Gadget), Colmn) 
  If *Column
    gtk_tree_view_column_set_alignment(*Column, Alignment);               title-alignment - fixed with ImportC
 
    *CellRenderers = gtk_tree_view_column_get_cell_renderers_(*Column)
    If *CellRenderers
      Count = g_list_length_(*CellRenderers);                             number of columns
      For Index = 0 To Count-1
        g_object_set_double(g_list_nth_data_(*CellRenderers, Index), "xalign", Alignment, #Null)
      Next Index         
      g_list_free_(*CellRenderers)
    EndIf
    gtk_widget_queue_draw_(GadgetID(Gadget));                             force Redraw
  EndIf
EndProcedure

;-
;- Example
Procedure CreateWindow_Main()
	Protected.l I, O
	Protected *Column

	If OpenWindow(#MainWin, #WinX, #WinY, #WinW, #WinH, "Column alignment", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
		ListIconGadget(#LIG, 5, 5, 480, 380, "Left", 70, #PB_ListIcon_AlwaysShowSelection | #PB_ListIcon_GridLines | #PB_ListIcon_CheckBoxes)
		AddGadgetColumn(#LIG, O, "Mid", 70)
		AddGadgetColumn(#LIG, O, "Right", 70)
		For O= 3 To 4
			AddGadgetColumn(#LIG, O, "column "+Str(O+ 1), 70)
		Next O
		For I= 1 To 20
			AddGadgetItem(#LIG, -1, Str(I)+".1")
		Next I
		
		For O= 1 To 4
			For I= 0 To 19
				SetGadgetItemText(#LIG, I, Str(I+1)+"."+Str(O+1), O)
			Next I
		Next O
		
		For O= 3 To 4
			For I= 0 To 19
				SetGadgetItemText(#LIG, I, Str(20-I)+"."+Str(O+1), O)
			Next I
		Next O
	EndIf

EndProcedure

CreateWindow_Main()

SetListIconColumnFormat(#LIG, 0, 0.0);    JustifyColumnLeft
SetListIconColumnFormat(#LIG, 1, 0.5);    JustifyColumnCenter
SetListIconColumnFormat(#LIG, 2, 1.0);    JustifyColumnRight

Repeat
	gEvent= WaitWindowEvent()

	Select gEvent
		Case #PB_Event_CloseWindow
			gQuit= #True
	EndSelect
	
Until gQuit
; IDE Options = PureBasic 5.30 (Linux - x86)
; CursorPosition = 56
; FirstLine = 38
; Folding = -
; EnableXP
; CurrentDirectory = /home/charly-xubuntu/Programming/PureBasic/purebasic/