﻿;======================================================================
; Module/File:     LIG_ColumnReorderable.pb - Linux
; Function:        LIG: Alle Spalten sind umsortierbar per Drag&Drop - Linux
; Author:          Oma (Charly Bauer)
; Date:            Juli 09, 2014
; Version:         0.1
; Target Compiler: PureBasic 5.22 LTS - Linux x86
; Target OS:       Linux - Xubuntu
; License:         Free, unrestricted, no warranty
;======================================================================


EnableExplicit
; 
; ImportC ""
; 	 gtk_tree_view_get_n_columns(*tree_view.GtkTreeView)
; 	 gtk_tree_view_column_get_tree_view(*tree_column)
; EndImport

;Window Variablen
#MainWin= 0
#LIG= 0
#WinX= 200
#WinY= 200
#WinW= 500
#WinH= 400

Global.l gEvent, gQuit

;- Functions ...
Procedure.i LIG_CountGadgetColumns(Gadget);                LIG: Anzahl Spalten holen
	Protected *ColumnList= gtk_tree_view_get_columns_(GadgetID(Gadget));       Zeiger auf Spalten
	Protected Columns= g_list_length_(*ColumnList)
	g_list_free_(*ColumnList)
	ProcedureReturn Columns
EndProcedure

; Procedure.i LIG_CountGadgetColumns(Gadget);                LIG: Anzahl Spalten holen - funktioniert bisher nicht
; 	ProcedureReturn gtk_tree_view_get_n_columns_(GadgetID(Gadget))
; EndProcedure

Procedure LIG_SetHeadersReorderable(Gadget)
	Protected.i I
	Protected *Column
	
	If Gadget= #LIG;                                                                  ListIconGadget #LIG: Alle Spalten-Header anklickbar
		For I = 0 To LIG_CountGadgetColumns(Gadget)- 1
			*Column = gtk_tree_view_get_column_(GadgetID(Gadget), I);                       LINUX-API - get the pointer to the column
			If *Column
				gtk_tree_view_column_set_reorderable_(*Column, #True)
			EndIf
		Next I
	EndIf
EndProcedure

;-
;- Example
Procedure CreateWindow_Main()
	Protected.l I, O
	Protected *Column
	#Img1= 0
	#Img2= 1
	If OpenWindow(#MainWin, #WinX, #WinY, #WinW, #WinH, "Move columns by drag&drop", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
		ListIconGadget(#LIG, 5, 5, 480, 380, "Spalte 1", 70, #PB_ListIcon_AlwaysShowSelection | #PB_ListIcon_GridLines | #PB_ListIcon_CheckBoxes)
		For O= 1 To 4
			AddGadgetColumn(#LIG, O, "Spalte "+Str(O+ 1), 70)
		Next O
		For I= 1 To 20
			AddGadgetItem(#LIG, -1, Str(I)+".1")
		Next I
		
		For O= 1 To 4
			For I= 0 To 19
				SetGadgetItemText(#LIG, I, Str(I+1)+"."+Str(O+1), O)
			Next I
		Next O
		
		For O= 3 To 4
			For I= 0 To 19
				SetGadgetItemText(#LIG, I, Str(20-I)+"."+Str(O+1), O)
			Next I
		Next O
	EndIf
	
	LIG_SetHeadersReorderable(#LIG)
EndProcedure

CreateWindow_Main()

Repeat
	gEvent= WaitWindowEvent()

	Select gEvent
		Case #PB_Event_CloseWindow
			gQuit= #True
	EndSelect
	
Until gQuit
; IDE Options = PureBasic 5.30 (Linux - x86)
; CursorPosition = 62
; FirstLine = 54
; Folding = -
; EnableXP
; CurrentDirectory = /home/charly-xubuntu/Programming/PureBasic/purebasic/