﻿;======================================================================
; Module/File:     LIG_SearchNative.pb - Linux
; Function:        native Search in LIG-column - Linux
; Author:          Omi (Charly Bauer)
; Date:            Aug. 16, 2014
; Version:         0.1
; Target Compiler: PureBasic 5.22 LTS - Linux x86
; Target OS:       Linux - Xubuntu
; License:         Free, unrestricted, no warranty whatsoever
;======================================================================

EnableExplicit

; Object constants
#MainWin= 0
#LIG= 0
#Txt= 1

#WinX= 200
#WinY= 200
#WinW= 500
#WinH= 400

Global.l gEvent, gQuit
Global.s Dim Zeile(20)

DeclareC SearchInTreeView(*model, column, *key, iter, *search_data)


Procedure CreateWindow_Main()
	Protected.l I, O

	If OpenWindow(#MainWin, #WinX, #WinY, #WinW, #WinH, "native Search in LIG", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
		ListIconGadget(#LIG, 5, 30, 480, 355, "column 1", 100, #PB_ListIcon_AlwaysShowSelection | #PB_ListIcon_GridLines)
		TextGadget(#Txt, 5, 5, 300, 20, "select row and type the search item ...")
		For O= 1 To 2
			AddGadgetColumn(#LIG, O, "column "+Str(O+ 1), 100)
		Next O
		
		Restore Surnames
		For I= 0 To 20
			Read.s Zeile(I)
		Next I
		SortArray(Zeile(), #PB_Sort_NoCase)
		
		For I= 0 To 20
			AddGadgetItem(#LIG, -1, Zeile(I))
		Next I
		
		;gtk_tree_view_set_enable_search_(GadgetID(#LIG), #True);                        must be ON
		gtk_tree_view_set_search_column_(GadgetID(#LIG), 0);                            set column 0 for search
		gtk_tree_view_set_search_equal_func_(GadgetID(#LIG), @SearchInTreeView(), #Null, 0); set function for verification
	EndIf
EndProcedure

Procedure.s UTF8ToAscii(UTF8.s);                                     converts UTF8 to Ascii-String
	Protected *mem= AllocateMemory(StringByteLength(UTF8, #PB_UTF8) + 1)
	Protected *len= PokeS(*mem, UTF8, -1,  #PB_Ascii)
	Protected.s SAscii= PeekS(*mem, -1, #PB_UTF8)
	FreeMemory(*mem)
	ProcedureReturn SAscii
EndProcedure

ProcedureC SearchInTreeView(*model, column, *key, iter, *search_data)
	;   every path (line) which partially agrees in systemsearch is sent to this function
	;   on every change of editfield
	Protected.i I, Indices, Found= #True
	Protected.s Search= PeekS(*key);                                                  current search-string in UTF8-Format
	
	Search= UTF8ToAscii(Search);                                                      convert search-string to Ascii
	
	Indices= PeekL(gtk_tree_path_get_indices_(gtk_tree_model_get_path_(*model, iter))); get path from iter, then index (LIG-line) from path
	
	If FindString(GetGadgetItemText(#LIG, Indices, column), Search, 1, #PB_String_NoCase); own check to verify the suggestion
		Found= #False
	EndIf
	
	ProcedureReturn Found;                                                            #False = Ok !
EndProcedure


CreateWindow_Main()

Repeat
	gEvent= WaitWindowEvent()
	
	Select gEvent
		Case #PB_Event_CloseWindow
			gQuit= #True
	EndSelect
	
Until gQuit
End

DataSection
	Surnames:
	Data.s "Bauer", "Müller", "Meier", "Maier", "Huber",
	       "Schmidt", "Schreiner", "Taler", "Bach", "Binder",
	       "Hofer", "Schneider", "Bader", "Berger", "Klein", 
	       "Groß", "Kaiser", "König", "Graf", "Weber", "Zauner"
EndDataSection
; IDE Options = PureBasic 5.22 LTS (Linux - x86)
; CursorPosition = 65
; FirstLine = 47
; Folding = -
; EnableXP
; CurrentDirectory = /home/charly-xubuntu/Programming/PureBasic/purebasic/