﻿;======================================================================
; Module/File:     File_GetSymLink.pb - LINUX
; Function:        Get a symbolic link or 0-pointer - Linux
; Author:          Oma (Charly Bauer)
; Date:            Sep. 08, 2014
; Version:         0.1
; Target Compiler: PureBasic 5.22
; Target OS:       Linux - Ubuntu
; License:         Free, unrestricted, no warranty
;======================================================================

;example from my system:
;a link: "/usr/share/icons/default.kde4/16x16/actions/im-skype.png"
;a file: "/usr/share/icons/default.kde4/16x16/actions/zoom-select.png"

EnableExplicit

; Object constants
#MainWin  = 0
#Button1  = 0

#WinX=300
#WinY=200
#WinW=300
#WinH=100

Global.l gEvent, gQuit, Link
Global.s Filename, LastPath= "/usr/share/icons/"
Global *error

Procedure FileExist(FN$)
	Protected.i Ret= #True
	If FileSize(FN$)= -1
		Ret=#False
	EndIf
	ProcedureReturn Ret
EndProcedure


If OpenWindow(#MainWin, #WinX, #WinY, #WinW, #WinH, "Get link", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
	ButtonGadget(#Button1, 5, 5, 150, 26, "Choose File to check ...")
	
	Repeat
		gEvent= WaitWindowEvent()
		
		Select gEvent
			Case #PB_Event_CloseWindow
				gQuit= #True
			Case #PB_Event_Gadget
				If EventGadget()= #Button1
					Filename= OpenFileRequester("Choose file or link to check ...", LastPath, "Alle Dateien (*.*)|*.*", 0)
					If FileExist(Filename)
						If GetFileAttributes(Filename) & #PB_FileSystem_Link;    is link?
							*error= 0;                                             must be 0 for call
							Link= g_file_read_link_(@Filename, @*error);           pointer to string
							If Link;                                               0 if it's no link
								Debug "link to: " + PeekS(Link);                     read target-path
							EndIf
							LastPath= GetPathPart(Filename)
						Else
							Debug "no link"
						EndIf
					EndIf
				EndIf
		EndSelect
		
	Until gQuit
EndIf
; IDE Options = PureBasic 5.30 (Linux - x86)
; CursorPosition = 53
; FirstLine = 27
; Folding = -
; EnableXP