﻿;======================================================================
; Module/File:     GetNumLockState - LINUX
; Function:        Get key and shift - Linux
; Author:          Oma (Charly Bauer)
; Date:            Sep 06, 2014
; Version:         0.1
; Target Compiler: PureBasic 5.22
; Target OS:       Linux - Ubuntu
; License:         Free, unrestricted, no warranty
;======================================================================

;Shift-States: Bit (depends on installation)
; 0 = [Shift]
; 1 = [CapsLock]
; 2 = [Control]
; 3 = [Alt]
; 4 = [NumLock]
; 5 = 
; 6 = 
; 7 = [AltGr]
; 8 =
;
;26 = [Menue]

#MainWin= 0

Global.i gEvent

ProcedureC KeyPressCallback(*widget, *event.GdkEventKey, *udata)
	Protected.i I, State, Pressed
	Protected.a KeyAsc
	Protected.l KeyWord
	Protected.s StateKeys, StateNames= "[Shift] [CapsLock] [Control] [Alt] [NumLock] [] [] [AltGr]"
	
	Pressed= *event\type
	KeyAsc = *event\keyval & $FF
	KeyWord= *event\keyval & $FFFF
	State  = *event\state
	For I= 0 To 7
		If (State >> I) & 1
			StateKeys+ StringField(StateNames, I+ 1, " ")
		EndIf
	Next I
	If KeyWord & $8000
		StateKeys+ "[Numberpad]"
		;(1) auch Bit 7 von KeyAsc gesetzt => ausblenden KeyAsc & $7F
	EndIf
	
	Debug #DOUBLEQUOTE$ + PeekS(*event\string) + #DOUBLEQUOTE$ + " = BYTE (ASC): " + Str(KeyAsc) + "/" + Str(KeyAsc & $7F) + ", WORD: " + Str(KeyWord)
	Debug "State: " + Str(State) + " = " + StateKeys
	;Debug "Pressed: " + Str(Pressed)
	Debug ""
EndProcedure

If OpenWindow(#MainWin, #PB_Any, #PB_Any, 200, 100, "keyPress to debug")
	g_signal_connect_(WindowID(#MainWin), "key_press_event", @KeyPressCallback(), #Null)

	Repeat
		gEvent = WaitWindowEvent()
	
	Until gEvent = #PB_Event_CloseWindow
EndIf
; IDE Options = PureBasic 5.30 (Linux - x86)
; CursorPosition = 11
; Folding = -
; EnableXP