﻿;======================================================================
; Module/File:     EditField_AddIconWithFunctions.pb - Linux
; Function:        Fügt Icon(s) zum StringGadget (GtkEntry) hinzu mit Funktionen, UTF8 - Linux
; Author:          Oma (Charly Bauer)
; Date:            Juli 07, 2014
; Version:         0.1
; Target Compiler: PureBasic 5.22 LTS - Linux x86
; Target OS:       Linux - Xubuntu
; License:         Free, unrestricted, no warranty
;======================================================================

ImportC ""
	gtk_entry_set_icon_from_stock(*entry.GtkEntry, icon_pos, *stock_id)
	gtk_entry_set_icon_activatable(*entry.GtkEntry, icon_pos, activatable)
	gtk_entry_set_icon_sensitive(*entry.GtkEntry, icon_pos, sensitive)
	gtk_entry_set_icon_tooltip_text(*entry.GtkEntry, icon_pos, *tooltip);  UTF8-Problem mit Umlauten (p-utf8)
EndImport

EnableExplicit

; Object constants
#MainWin= 0
#Strg1  = 0
#Strg2  = 1
#Strg3  = 2
#WinX= 300
#WinY= 200
#WinW= 300
#WinH= 150

Global.l gEvent, gQuit
Global *gMem


Procedure.l UTF8(S.s);                                     gMem nach Aufruf freigeben
	*gMem= AllocateMemory(Len(S) * 4 / SizeOf(Character) + 1);      bisher Global wg. Freigabe
	Protected *len= PokeS(*gMem, S, -1,  #PB_UTF8);        UTF-8 benötigt, wandeln
	ProcedureReturn *gMem
EndProcedure;             protectet *mem würde noch nicht freigegeben werden!!! Rück- und Übergabe als UTF8-String noch mit Fehlermeldung

ProcedureC EntryIconClicked(*widget, *signal, user_data)
    ;*widget contains the data given at creation time of this handler
    ;*signal contains the detailed signal
    Select *widget
    	Case GadgetID(#Strg1)
    		Debug "StringGadget 1"
    		If *signal= 0;                           left icon
    			Debug "Left Icon: Search"
    		EndIf
    	Case GadgetID(#Strg2)
    		Debug "StringGadget 2"
    		If *signal= 1;                           right icon
    			Debug "Right Icon: Clear"
    			SetGadgetText(#Strg2, "")
    		EndIf
    	Case GadgetID(#Strg3)
    		Debug "StringGadget 3"
    		If *signal= 0;                           left icon
    			Debug "Left Icon: Search"
    		ElseIf *signal= 1;                       right icon
    			Debug "Right Icon: Clear"
    		EndIf
    EndSelect
    Debug ""
EndProcedure


If OpenWindow(#MainWin, #WinX, #WinY, #WinW, #WinH, "Add StringGadget-Icons with functions", #PB_Window_SystemMenu | #PB_Window_WindowCentered)
	StringGadget(#Strg1, 5, 5, 150, 26, "Click Icon")
	StringGadget(#Strg2, 5, 35, 150, 26, "Click Icon")
	StringGadget(#Strg3, 5, 65, 150, 26, "Click Icons")
	
	;add left icon
	gtk_entry_set_icon_from_stock(GadgetID(#Strg1), 0, @"gtk-find");    '0' = pos left, System-Icon
	gtk_entry_set_icon_activatable(GadgetID(#Strg1), 0, #True)
	gtk_entry_set_icon_sensitive(GadgetID(#Strg1), 0, #True)
	
	;add right icon
	gtk_entry_set_icon_from_stock(GadgetID(#Strg2), 1, @"gtk-clear");  '1' = pos right
	gtk_entry_set_icon_activatable(GadgetID(#Strg2), 1, #True)
	gtk_entry_set_icon_sensitive(GadgetID(#Strg2), 1, #True)
	
	;add both icons
	gtk_entry_set_icon_from_stock(GadgetID(#Strg3), 0, @"gtk-find");    '0' = pos left
	gtk_entry_set_icon_activatable(GadgetID(#Strg3), 0, #True)
	gtk_entry_set_icon_sensitive(GadgetID(#Strg3), 0, #True)
	gtk_entry_set_icon_from_stock(GadgetID(#Strg3), 1, @"gtk-clear");  AND '1' = pos left
	gtk_entry_set_icon_activatable(GadgetID(#Strg3), 1, #True)
	gtk_entry_set_icon_sensitive(GadgetID(#Strg3), 1, #True)
	
	;add tooltips for icons
	gtk_entry_set_icon_tooltip_text(GadgetID(#Strg1), 0, UTF8("Tooltip zum zusätzlichen Icon. Hier könnte die Suche gestartet werden!")) : FreeMemory(*gMem);  UTF8-Problem
	gtk_entry_set_icon_tooltip_text(GadgetID(#Strg2), 1, UTF8("Tooltip for additional icon. Here you can delete the text!")) : FreeMemory(*gMem)
	gtk_entry_set_icon_tooltip_text(GadgetID(#Strg3), 0, UTF8("Tooltip for additional icon. Here you could start searching!")) : FreeMemory(*gMem)
	gtk_entry_set_icon_tooltip_text(GadgetID(#Strg3), 1, UTF8("Tooltip zum zusätzlichen Icon. Hier könnte der Text gelöscht werden!")) : FreeMemory(*gMem)
	
	g_signal_connect_data_(GadgetID(#Strg1), "icon_press", @EntryIconClicked(), 0, #Null, #Null)
	g_signal_connect_data_(GadgetID(#Strg2), "icon_press", @EntryIconClicked(), 0, #Null, #Null)
	g_signal_connect_data_(GadgetID(#Strg3), "icon_press", @EntryIconClicked(), 0, #Null, #Null)

	
	Repeat
		gEvent= WaitWindowEvent()
		
		Select gEvent
			Case #PB_Event_CloseWindow
				gQuit= #True
		EndSelect
		
	Until gQuit
EndIf
; IDE Options = PureBasic 5.30 (Linux - x86)
; CursorPosition = 62
; FirstLine = 28
; Folding = -
; EnableXP
; CurrentDirectory = /home/charly-xubuntu/Programming/PureBasic/purebasic/