﻿;======================================================================
; Module/File:     EditField_GetSelection.pb - Linux
; Function:        StringGadget: holt markierten Bereich mit UTF-8 - Linux
; Author:          Oma (Charly Bauer)
; Date:            Juli 31, 2014
; Version:         0.1
; Target Compiler: PureBasic 5.22 LTS - Linux x86
; Target OS:       Linux - Xubuntu
; License:         Free, unrestricted, no warranty
;======================================================================

EnableExplicit

; Object constants
#MainWin= 0
#But   = 0
#String = 1

#WinX=300
#WinY=200
#WinW=250
#WinH=200

Global.l gEvent, gQuit, gCounter

;- Functions ...
ProcedureC Edit_Changed(*widget, signal, user_data)
; 	Debug signal
; 	Debug user_data
; Debug gCounter
; gCounter+ 1
EndProcedure


Procedure.s Ascii(S.s)
	Protected *mem= AllocateMemory(Len(S) * SizeOf(Character) + 1)
	Protected *len= PokeS(*mem, S, -1,  #PB_Ascii);        UTF-8 benötigt, wandeln
	Protected.s Sasc= PeekS(*mem, -1, #PB_UTF8)
	FreeMemory(*mem)
	ProcedureReturn Sasc
EndProcedure

Procedure.s SelectedStringpart(Gadget)
	Protected start_pos, end_pos
	Protected *mem
	If gtk_editable_get_selection_bounds_(GadgetID(Gadget), @start_pos, @end_pos)
		*mem= gtk_editable_get_chars_(GadgetID(Gadget), start_pos, end_pos)
		ProcedureReturn PeekS(*mem)
	Else
		ProcedureReturn ""
	EndIf
EndProcedure

;- Example ...

If OpenWindow(#MainWin, #WinX, #WinY, #WinW, #WinH, "StringGadget-Cursorpos", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
	
	StringGadget(#String, 10, 5, 230, 25, "Select a part of this string (UTF-8) ÄÖÜ")
	ButtonGadget(#But, 10, 35, 200, 25, "then push me")
	
	SetActiveGadget(#String)
	
	g_signal_connect_data_(GadgetID(#String), "changed", @Edit_Changed(), 25, #Null, #Null)
	
	Repeat
		gEvent= WaitWindowEvent()
		
		Select gEvent
				
			Case #PB_Event_CloseWindow
				gQuit= #True
				
			Case #PB_Event_Gadget
				If EventGadget()= #but
					Debug Ascii(SelectedStringpart(#String));        UTF8 in Ascii rückgewandelt
				EndIf
				
		EndSelect
	Until gQuit
EndIf
; IDE Options = PureBasic 5.30 (Linux - x86)
; CursorPosition = 25
; Folding = -
; EnableXP
; CurrentDirectory = /home/charly-xubuntu/Programming/PureBasic/purebasic/