﻿;======================================================================
; Module/File:     Toolbar_DemoAPIAdds.pb - Linux
; Function:        Toolbar - Demo API-widgets & functions für PB-ToolbarGadget - Linux
; Author:          Shardik (& a little Omi)
; Date:            Aug. 07, 2014
; Version:         0.1
; Target Compiler: PureBasic 5.22 LTS - Linux x86
; Target OS:       Linux - Xubuntu
; License:         Free, unrestricted, no warranty
;======================================================================

ImportC ""
	gtk_widget_set_tooltip_text(*widget.GtkWidget, *text.p-utf8)
	gtk_widget_set_visible(*widget.GtkWidget, visible)
	gtk_orientable_set_orientation(*orientable, orientation)
	gtk_alignment_new(xalign.f, yalign.f, xscale.f, yscale.f)
EndImport

;g_object_set_property(GObject *object, const gchar *property_name, const GValue *value)

; Object constants
#MainWin= 0
#TBar1  = 0
#CBox   = 0

Global.i Null
Global.GtkToolItem *TBar1Button1, *TBar1Button2, *TBar1Button3, *TBar1TButton1
Global.GtkSeparatorToolItem *TBarSep1, *TBarSep2


Procedure ChangeToolBarIconSize(ToolBarIconSize.I)
	; ----- Change icon size of ToolBar
	gtk_toolbar_set_icon_size_(ToolBarID(#TBar1), ToolBarIconSize)
	
	; ----- Redisplay window to show modified ToolBar
	gtk_widget_show_all_(WindowID(#MainWin))
EndProcedure

Procedure ChangeShowOverloadArrow(*toolbar.GtkToolbar, Gadget)
	; ----- Change display of overflow-arrow, if needed
	gtk_toolbar_set_show_arrow_ (*toolbar, Bool(GetGadgetState(Gadget) & #PB_Checkbox_Checked))
EndProcedure

ProcedureC ToolbarButton_clicked(*widget, *signal, *user_data);      redirects to #PB_Event_Menu & EventMenu(), Opi-added
	PostEvent(#PB_Event_Menu, *signal, *widget);                       *signal= #Window, *widget= item-Adresse
EndProcedure

ProcedureC ToolbarButton_toggled(*widget, *signal, *user_data);      redirects to  #PB_Event_Menu & EventMenu(), Opi-added
	PostEvent(#PB_Event_Menu, *widget, *signal);                       here *signal= item-Adresse, *widget= #Window
EndProcedure

Procedure Create_Window_Main()
	Protected *toolitem.GtkToolItem
	OpenWindow(#MainWin, 200, 100, 440, 340, "ToolBar", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
	
	ComboBoxGadget(#CBox, 0, 0, 80, 25, #PB_ComboBox_Editable)
	AddGadgetItem(#CBox, -1, "Item 1")
	AddGadgetItem(#CBox, -1, "Item 2")
	AddGadgetItem(#CBox, -1, "Item 3")
	SetGadgetState(#CBox, 0)
	
	; ----- Create toolbar
	CreateToolBar(#TBar1, WindowID(#MainWin))
	; ----- Add API tool button 1
	*TBar1Button1= gtk_tool_button_new_from_stock_(#GTK_STOCK_NEW)
	gtk_toolbar_insert_(ToolBarID(#TBar1), *TBar1Button1, -1)
	; ----- Add API tool button 2
	*TBar1Button2= gtk_tool_button_new_from_stock_(#GTK_STOCK_OPEN)
	gtk_toolbar_insert_(ToolBarID(#TBar1), *TBar1Button2, -1)
	
	; ----- Add Separator Space
	*TBarSep1= gtk_separator_tool_item_new_()
	gtk_separator_tool_item_set_draw_(*TBarSep1, #False)
	gtk_toolbar_insert_(ToolBarID(#TBar1), *TBarSep1, -1)
	gtk_widget_set_tooltip_text(*TBarSep1, @"a 'space'-separator")
	
	; ----- Add API tool button 3
	*TBar1Button3= gtk_tool_button_new_from_stock_(#GTK_STOCK_SAVE_AS)
	gtk_toolbar_insert_(ToolBarID(#TBar1), *TBar1Button3, -1)
	gtk_widget_set_sensitive_(*TBar1Button3, #False);                  disables Button 3
	
	; ----- Add Separator Bar
	*TBarSep2= gtk_separator_tool_item_new_()
	gtk_separator_tool_item_set_draw_(*TBarSep2, #True)
	gtk_toolbar_insert_(ToolBarID(#TBar1), *TBarSep2, -1)
	gtk_widget_set_tooltip_text(*TBarSep2, @"a 'line'-separator")
	
	; ----- Add API tool togglebutton
	*TBar1TButton1= gtk_toggle_tool_button_new_from_stock_(#GTK_STOCK_UNDERLINE)
	gtk_toolbar_insert_(ToolBarID(#TBar1), *TBar1TButton1, -1)
	gtk_widget_set_tooltip_text(*TBar1TButton1, @"a toggle-button")
	
	
	*alignment.GtkWidget= gtk_alignment_new(0.0, 0.5, 0.0, 0.0)
	
	*toolitem = gtk_tool_item_new_()
	gtk_tool_item_set_visible_horizontal_(*toolitem, #True)
	gtk_toolbar_insert_(ToolBarID(#TBar1), *toolitem, -1)
	gtk_widget_reparent_(GadgetID(#CBox), *toolitem)
; 	gtk_widget_reparent_(*toolitem, *alignment)
; 	;	gtk_tool_item_set_expand_(*toolitem, #False)
; 	Property.GValue
; 	Property\g_type = 32
; 	Property\data\v_float = 0.0
; 	g_object_set_property_(*alignment, @"yscale", @Property)
	
	gtk_combo_box_popup_(GadgetID(#CBox))
	gtk_combo_box_popdown_(GadgetID(#CBox))
	
	; ----- Define FrameGadget with 5 OptionGadgets for the different icon sizes
	FrameGadget(0, 10, 5, 150, 165, "ToolBar icon size:")
	OptionGadget(1, 10,  20, 110, 25, "16x16")
	OptionGadget(2, 10,  45, 110, 25, "18x18")
	OptionGadget(3, 10,  70, 110, 25, "20x20")
	OptionGadget(4, 10,  95, 110, 25, "24x24")
	OptionGadget(5, 10, 120, 110, 25, "32x32")
	OptionGadget(6, 10, 145, 110, 25, "48x48")
	ChangeToolBarIconSize(#GTK_ICON_SIZE_MENU)
	SetGadgetState(1, #True)
	
	; ----- Define FrameGadget with 3 display styles
	FrameGadget(7, 170, 5, 160, 90, "ToolBar style:")
	OptionGadget( 8, 170, 20, 110, 25, "Icon only")
	OptionGadget( 9, 170, 45, 110, 25, "Label only")
	OptionGadget(10, 170, 70, 110, 25, "Icon plus label")
	SetGadgetState(10, #True)
	gtk_toolbar_set_style_(ToolBarID(#TBar1), #GTK_TOOLBAR_BOTH)
	
	; ----- Define some functions, see each text
	CheckBoxGadget(11, 170, 100, 150, 25, "Overflow arrow")
	SetGadgetState(11,  #PB_Checkbox_Checked)
	GadgetToolTip(11, "choose dialog-size-icons 48x48 to see")
	
	CheckBoxGadget(12, 170, 125, 150, 25, "Button 2 visible")
	SetGadgetState(12,  #PB_Checkbox_Checked)
	GadgetToolTip(12, "switch visibility of button 2")
	
	CheckBoxGadget(13, 170, 150, 150, 25, "Button 3 sensitive")
	GadgetToolTip(13, "switch sensitivity from button 3")
	
	CheckBoxGadget(14, 170, 175, 150, 25, "ToggleButton state")
	GadgetToolTip(14, "remote-switch for ToggleButton")
	
	CheckBoxGadget(15, 170, 200, 150, 25, "Toolbar orientation")
	GadgetToolTip(15, "alters Toolbar-orientation")
	
	; ----- Redisplay window to show modified ToolBar
	gtk_widget_show_all_(WindowID(#MainWin))
	
	; ----- Connect signals to TBar-items to replace events to EventMenu / EventMenu(); Opi-added
	g_signal_connect_data_(*TBar1Button1, "clicked", @ToolbarButton_clicked(), #MainWin, #Null, #Null); #G_CONNECT_SWAPPED)
	g_signal_connect_data_(*TBar1Button2, "clicked", @ToolbarButton_clicked(), #MainWin, #Null, #Null); #G_CONNECT_SWAPPED)
	g_signal_connect_data_(*TBar1Button3, "clicked", @ToolbarButton_clicked(), #MainWin, #Null, #Null); #G_CONNECT_SWAPPED)
	g_signal_connect_data_(*TBar1TButton1, "toggled", @ToolbarButton_toggled(), #MainWin, #Null, #G_CONNECT_SWAPPED); #G_CONNECT_SWAPPED)
EndProcedure

Create_Window_Main()

Repeat
	Select WaitWindowEvent()
		Case #PB_Event_CloseWindow
			Break
		Case #PB_Event_Gadget
			Select EventGadget()
				Case 1 ; 16x16
					ChangeToolBarIconSize(#GTK_ICON_SIZE_MENU)
				Case 2 ; 18x18
					ChangeToolBarIconSize(#GTK_ICON_SIZE_SMALL_TOOLBAR)
				Case 3 ; 20x20
					ChangeToolBarIconSize(#GTK_ICON_SIZE_BUTTON)
				Case 4 ; 24x24
					ChangeToolBarIconSize(#GTK_ICON_SIZE_LARGE_TOOLBAR)
				Case 5 ; 32x32
					ChangeToolBarIconSize(#GTK_ICON_SIZE_DND)
				Case 6 ; 48x48
					ChangeToolBarIconSize(#GTK_ICON_SIZE_DIALOG)
				Case 8
					gtk_toolbar_set_style_(ToolBarID(#TBar1), #GTK_TOOLBAR_ICONS)
				Case 9
					gtk_toolbar_set_style_(ToolBarID(#TBar1), #GTK_TOOLBAR_TEXT)
				Case 10
					gtk_toolbar_set_style_(ToolBarID(#TBar1), #GTK_TOOLBAR_BOTH)
				Case 11
					ChangeShowOverloadArrow(ToolBarID(#TBar1), 11);                           alters visibility of OverloadArrow if needed
				Case 12
					gtk_widget_set_visible(*TBar1Button2, GetGadgetState(12));                alters visibility of Button 2
				Case 13
					gtk_widget_set_sensitive_(*TBar1Button3, GetGadgetState(13));             alters sensitivity of Button 3
				Case 14
					gtk_toggle_tool_button_set_active_(*TBar1TButton1, GetGadgetState(14));   alters state of ToggleButton
				Case 15
					gtk_orientable_set_orientation(ToolBarID(#TBar1), GetGadgetState(15));    alters Toolbar-Orientation: #GTK_ORIENTATION_HORIZONTAL= 0, #GTK_ORIENTATION_VERTICAL= 1
			EndSelect
		Case #PB_Event_Menu;                                                            redirected signals from ToolButtons
			Select EventMenu();                                                           Dangerous? Adresses are used
				Case *TBar1Button1
					Debug "Toolbar-Button 1"
				Case *TBar1Button2
					Debug "Toolbar-Button 2"
				Case *TBar1Button3
					Debug "Toolbar-Button 3"
				Case *TBar1TButton1
					Debug "Toolbar-ToggleButton 1: state= " + Str(gtk_toggle_tool_button_get_active_(*TBar1TButton1))
					SetGadgetState(14,  gtk_toggle_tool_button_get_active_(*TBar1TButton1))
			EndSelect
	EndSelect
ForEver
; IDE Options = PureBasic 5.30 (Linux - x86)
; CursorPosition = 53
; Folding = -
; EnableXP
; CurrentDirectory = /home/charly-xubuntu/Programming/PureBasic/purebasic/