﻿;======================================================================
; Module/File:     Trackbar_AllowFPValues.pb - Linux
; Function:        Trackbar: ermöglicht Fließkommawerte entgegen der PB-Version- Linux
; Author:          Oma (Charly Bauer)
; Date:            Aug. 13, 2014
; Version:         0.1
; Target Compiler: PureBasic 5.22 LTS - Linux x86
; Target OS:       Linux - Xubuntu
; License:         Free, unrestricted, no warranty
;======================================================================

ImportC ""
	gtk_window_set_opacity(*window.GtkWindow, opacity.d)
	gtk_scale_clear_marks(*scale.GtkScale)
	gtk_scale_add_mark(*scale.GtkScale, value.d, position.i, *markup)
	gtk_range_get_value.d(*range.GtkRange)
EndImport

EnableExplicit

; Object constants
#MainWin  = 0
#TBar1    = 0
#SPBret   = 1
#SGtkRet  = 2

#WinX     = 300
#WinY     = 200
#WinW     = 250
#WinH     = 200

Global.i I, gEvent, gQuit, gCounter
Global *gWidget.GtkWidget, *gRange.GtkRange

ProcedureC GetScaleValue(*widget, user_data)
	SetGadgetText(#SGtkRet, StrD(gtk_range_get_value(*widget)))
EndProcedure

If OpenWindow(#MainWin, #WinX, #WinY, #WinW, #WinH, "trackbar w. 'double'-type-value", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
	TextGadget(#PB_Any, 5, 20, 90, 20, "'double'-steps")
	TextGadget(#PB_Any, 5, 80, 100, 20, "PB-returnvalue  :")
	StringGadget(#SPBret, 100, 75, 50, 25, "", #PB_String_ReadOnly)
	TextGadget(#PB_Any, 5, 110, 100, 20, "Gtk-returnvalue:")
	StringGadget(#SGtkRet, 100, 105, 50, 25, "", #PB_String_ReadOnly)
	
	TrackBarGadget(#TBar1, 90, 5, 150, 40, 0, 2);                      no 'double'-parameters possible => need double instead PB-integer)
	
	; ----- additional trackbar settings ...
	*gWidget= GadgetID(#TBar1)
	gtk_scale_set_draw_value_(*gWidget, #True);                        display ON
	
	*gRange = *gWidget;                                                get range-class
	*gRange\adjustment\lower= 0.5;                                     set real lower-limit on 0.5
	*gRange\adjustment\upper= 1.5;                                     set real upper-limit on 1.5
	*gRange\adjustment\value= 1.0;                                     preset value
	
	gtk_scale_clear_marks(*gWidget);                                   no marks => wrong cause pb-int-parameter
	For I= 5 To 15
		gtk_scale_add_mark(*gWidget, I/10, #GTK_POS_TOP, #Null)
	Next I
	
	g_signal_connect_data_(*gWidget, "value-changed", @GetScaleValue(), *gWidget, #Null, #Null)
	
	Repeat
		gEvent= WaitWindowEvent()
		
		Select gEvent
			Case #PB_Event_CloseWindow
				gQuit= #True
			Case #PB_Event_Gadget
				If EventGadget()= #TBar1
					SetGadgetText(#SPBret, StrD(GetGadgetState(#TBar1)));      no 'double'-type return possible
				EndIf
		EndSelect
		
	Until gQuit
EndIf
; IDE Options = PureBasic 5.22 LTS (Linux - x86)
; CursorPosition = 8
; Folding = -
; EnableXP
; CurrentDirectory = /home/charly-xubuntu/Programming/PureBasic/purebasic/