﻿;======================================================================
; Module/File:     Window_SetTransparency.pb - Linux
; Function:        Window: setzt Transparenz -Linux
; Author:          Oma (Charly Bauer)
; Date:            Aug. 12, 2014
; Version:         0.1
; Target Compiler: PureBasic 5.22 LTS - Linux x86
; Target OS:       Linux - Xubuntu
; License:         Free, unrestricted, no warranty
;======================================================================

ImportC ""
	gtk_window_set_opacity(*window.GtkWindow, opacity.d)
	gtk_scale_clear_marks(*scale.GtkScale)
	gtk_scale_add_mark(*scale.GtkScale, value.d, position.i, *markup)
	gtk_range_get_value.d(*range.GtkRange)
EndImport

EnableExplicit

; Object constants
#MainWin= 0
#TBar1    = 0

#WinX=300
#WinY=200
#WinW=250
#WinH=200

Global.i I, gEvent, gQuit, gCounter
Global *gWidget.GtkWidget, *gRange.GtkRange

ProcedureC Trackbar_changed(*trackbar, user_data)
	; ----- set opacity with trackbar-position ...
	gtk_window_set_opacity(WindowID(#MainWin), gtk_range_get_value(*trackbar))
EndProcedure

If OpenWindow(#MainWin, #WinX, #WinY, #WinW, #WinH, "window-transparency", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
	TextGadget(#PB_Any, 5, 20, 90, 20, "transparency")
	TrackBarGadget(#TBar1, 90, 5, 150, 40, 0.5, 1);                    no lower-limit 0.5 possible (= 0) => need double instead PB-integer)
	
	; ----- set trackbar to adjust transparency ...
	*gWidget= GadgetID(#TBar1)
	gtk_scale_set_value_pos_(*gWidget, #GTK_POS_RIGHT);                additional display value at right side
	gtk_scale_set_draw_value_(*gWidget, #True);                        display ON
	gtk_scale_clear_marks(*gWidget);                                   no marks => wrong cause pb-int-parameter
	*gRange = *gWidget;                                                get range-class
	*gRange\adjustment\lower= 0.5;                                     set real lower-limit on 0.5
	*gRange\adjustment\value= 0.8;                                     preset value
	For I= 5 To 10
		gtk_scale_add_mark(*gWidget, I/10, #GTK_POS_TOP, #Null)
	Next I
	
	; ----- set event for trackbar-change
 	g_signal_connect_data_(*gWidget, "value-changed", @Trackbar_changed(), *gWidget, #Null, #Null)
 	
 	; ----- preset transparency ...
	gtk_window_set_opacity(WindowID(#MainWin), 0.8)
	
	Repeat
		gEvent= WaitWindowEvent()
		
		Select gEvent
			Case #PB_Event_CloseWindow
				gQuit= #True
			Case #PB_Event_Gadget
				;  see Trackbar_changed(*trackbar, user_data) for event
		EndSelect
		
	Until gQuit
EndIf
; IDE Options = PureBasic 5.22 LTS (Linux - x86)
; CursorPosition = 8
; Folding = -
; EnableXP
; CurrentDirectory = /home/charly-xubuntu/Programming/PureBasic/purebasic/